/* getkey.c generated by valac 0.52.3, the Vala compiler
 * generated from getkey.vala, do not modify */

/* Getting and ungetting key strokes

   Copyright (c) 1997-2021 Free Software Foundation, Inc.

   This file is part of GNU Zile.

   GNU Zile is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Zile is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */
/* Standard pauses in ds */

#include <glib.h>
#include <glib-object.h>

typedef guint Keystroke;
typedef enum  {
	FLAGS_NEED_RESYNC = 1 << 0,
	FLAGS_SET_UNIARG = 1 << 1,
	FLAGS_UNIARG_EMPTY = 1 << 2,
	FLAGS_DEFINING_MACRO = 1 << 3
} Flags;

#define TYPE_FLAGS (flags_get_type ())

extern Keystroke _last_key;
Keystroke _last_key = 0U;
extern Flags thisflag;
extern gint64 next_refresh;
gint64 next_refresh = (gint64) 0;
extern gint64 now;
gint64 now = 0LL;

#define GETKEY_DEFAULT -1
#define GETKEY_DELAYED 2000
#define MAX_RESYNC_MS 500
Keystroke lastkey (void);
Keystroke getkeystroke (gint delay);
Keystroke term_getkey (gint delay);
#define KBD_NOKEY ((Keystroke) G_MAXUINT)
GType flags_get_type (void) G_GNUC_CONST ;
void add_key_to_cmd (Keystroke key);
#define refresh_wait ((gint64) (MAX_RESYNC_MS * 1000))
Keystroke getkey (gint delay);
void term_redisplay (void);
void term_refresh (void);
Keystroke getkey_unfiltered (gint mode);
guint term_getkey_unfiltered (gint delay);
void waitkey (void);
void ungetkey (Keystroke key);
void pushkey (Keystroke key);
void term_ungetkey (Keystroke key);
void remove_key_from_cmd (void);

Keystroke
lastkey (void)
{
	Keystroke result = 0U;
#line 32 "src/getkey.vala"
	result = _last_key;
#line 32 "src/getkey.vala"
	return result;
#line 75 "getkey.c"
}

Keystroke
getkeystroke (gint delay)
{
	gboolean _tmp0_ = FALSE;
	Keystroke result = 0U;
#line 40 "src/getkey.vala"
	_last_key = term_getkey (delay);
#line 42 "src/getkey.vala"
	if (_last_key != KBD_NOKEY) {
#line 87 "getkey.c"
		Flags _tmp1_;
#line 42 "src/getkey.vala"
		_tmp1_ = thisflag;
#line 42 "src/getkey.vala"
		_tmp0_ = (_tmp1_ & FLAGS_DEFINING_MACRO) == FLAGS_DEFINING_MACRO;
#line 93 "getkey.c"
	} else {
#line 42 "src/getkey.vala"
		_tmp0_ = FALSE;
#line 97 "getkey.c"
	}
#line 42 "src/getkey.vala"
	if (_tmp0_) {
#line 43 "src/getkey.vala"
		add_key_to_cmd (_last_key);
#line 103 "getkey.c"
	}
#line 45 "src/getkey.vala"
	result = _last_key;
#line 45 "src/getkey.vala"
	return result;
#line 109 "getkey.c"
}

Keystroke
getkey (gint delay)
{
	Keystroke keycode = 0U;
	gboolean _tmp0_ = FALSE;
	Keystroke result = 0U;
#line 58 "src/getkey.vala"
	keycode = getkeystroke (0);
#line 60 "src/getkey.vala"
	now = g_get_monotonic_time ();
#line 62 "src/getkey.vala"
	if (keycode == KBD_NOKEY) {
#line 62 "src/getkey.vala"
		_tmp0_ = TRUE;
#line 126 "getkey.c"
	} else {
#line 62 "src/getkey.vala"
		_tmp0_ = now >= next_refresh;
#line 130 "getkey.c"
	}
#line 62 "src/getkey.vala"
	if (_tmp0_) {
#line 63 "src/getkey.vala"
		term_redisplay ();
#line 64 "src/getkey.vala"
		term_refresh ();
#line 65 "src/getkey.vala"
		next_refresh = now + refresh_wait;
#line 140 "getkey.c"
	}
#line 68 "src/getkey.vala"
	if (keycode == KBD_NOKEY) {
#line 69 "src/getkey.vala"
		keycode = getkeystroke (delay);
#line 146 "getkey.c"
	}
#line 71 "src/getkey.vala"
	result = keycode;
#line 71 "src/getkey.vala"
	return result;
#line 152 "getkey.c"
}

Keystroke
getkey_unfiltered (gint mode)
{
	Keystroke key = 0U;
	Flags _tmp0_;
	Keystroke result = 0U;
#line 75 "src/getkey.vala"
	key = (Keystroke) term_getkey_unfiltered (mode);
#line 77 "src/getkey.vala"
	_last_key = key;
#line 78 "src/getkey.vala"
	_tmp0_ = thisflag;
#line 78 "src/getkey.vala"
	if ((_tmp0_ & FLAGS_DEFINING_MACRO) == FLAGS_DEFINING_MACRO) {
#line 79 "src/getkey.vala"
		add_key_to_cmd (key);
#line 171 "getkey.c"
	}
#line 81 "src/getkey.vala"
	result = key;
#line 81 "src/getkey.vala"
	return result;
#line 177 "getkey.c"
}

void
waitkey (void)
{
#line 89 "src/getkey.vala"
	ungetkey (getkey (GETKEY_DELAYED));
#line 185 "getkey.c"
}

void
pushkey (Keystroke key)
{
#line 96 "src/getkey.vala"
	term_ungetkey (key);
#line 193 "getkey.c"
}

void
ungetkey (Keystroke key)
{
	Flags _tmp0_;
#line 103 "src/getkey.vala"
	pushkey (key);
#line 105 "src/getkey.vala"
	_tmp0_ = thisflag;
#line 105 "src/getkey.vala"
	if ((_tmp0_ & FLAGS_DEFINING_MACRO) == FLAGS_DEFINING_MACRO) {
#line 106 "src/getkey.vala"
		remove_key_from_cmd ();
#line 208 "getkey.c"
	}
}

